// DirectInput.cpp: CDirectInput NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "DirectInput.h"

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CDirectInput::CDirectInput()
{
	m_pDirectInput = NULL;
	m_pDeviceMouse = NULL;
	m_pDeviceKey = NULL;

	m_bInit = false;
}

CDirectInput::~CDirectInput()
{
	ReleaseAll();
}

bool CDirectInput::Initialize(HINSTANCE hinst,HWND hwnd)
{
	ReleaseAll();

	HRESULT hr;

	// DirectInput IuWFNg쐬
	hr = DirectInputCreate( hinst,DIRECTINPUT_VERSION,&m_pDirectInput,NULL );
	if( hr!=DI_OK )
		return false;

	// }EXpfoCX쐬
	hr = m_pDirectInput->CreateDevice( GUID_SysMouse,&m_pDeviceMouse,NULL );
	if( hr!=DI_OK )
		return false;
	m_pDeviceMouse->SetDataFormat(&c_dfDIMouse);
	hr = m_pDeviceMouse->SetCooperativeLevel( hwnd, DISCL_FOREGROUND | DISCL_EXCLUSIVE );
	if( hr!=DI_OK )
		return false;

	// L[{[hpfoCX쐬
	hr = m_pDirectInput->CreateDevice( GUID_SysKeyboard,&m_pDeviceKey,NULL );
	if( hr!=DI_OK )
		return false;
	m_pDeviceKey->SetDataFormat(&c_dfDIKeyboard);
	hr = m_pDeviceKey->SetCooperativeLevel( hwnd,DISCL_BACKGROUND|DISCL_NONEXCLUSIVE );
	if( hr!=DI_OK )
		return false;

	m_bInit = true;
	return true;
}

void CDirectInput::ReleaseAll()
{
	if( m_pDeviceMouse!=NULL )
	{
		AcquireMouse( false );
		m_pDeviceMouse->Release();
		m_pDeviceMouse = NULL;
	}
	if( m_pDeviceKey!=NULL )
	{
		AcquireKey( false );
		m_pDeviceKey->Release();
		m_pDeviceKey = NULL;
	}
	if( m_pDirectInput!=NULL )
	{
		m_pDirectInput->Release();
		m_pDirectInput = NULL;
	}

	m_bInit = false;
}

void CDirectInput::AcquireMouse(bool b)
{
	if( m_pDeviceMouse==NULL )
		return;

	if( b )	m_pDeviceMouse->Acquire();
	else	m_pDeviceMouse->Unacquire();
}

void CDirectInput::AcquireKey(bool b)
{
	if( m_pDeviceKey==NULL )
		return;

	if( b )	m_pDeviceKey->Acquire();
	else	m_pDeviceKey->Unacquire();
}

bool CDirectInput::GetKeyState(size_t size,char * st)
{
	if( m_pDeviceKey==NULL )
		return false;

	if( DI_OK!=m_pDeviceKey->GetDeviceState(size,(LPVOID)st) )
		return false; 

	return true;
}

bool CDirectInput::IsKeyDown(const int n)
{
	char buf[256];
	if( !GetKeyState(sizeof(buf),buf) )
		return false;

	if( buf[n] & 0x80 )
		return true;
	return false;
}

bool CDirectInput::GetMouseState(DIMOUSESTATE * st)
{
	if( m_pDeviceMouse==NULL )
		return false;

	m_pDeviceMouse->GetDeviceState( sizeof(DIMOUSESTATE),(LPVOID)st );
	return true;
}
