// DirectMusic.cpp: CDirectMusic NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "DirectMusic.h"
#include "inc.h"

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CDirectMusic::CDirectMusic()
{
	m_pDirectMusicPerf = NULL;

	m_bInit = false;
}

CDirectMusic::~CDirectMusic()
{
	ReleaseAll();
}

bool CDirectMusic::Initialize(HWND hwnd)
{
	ReleaseAll();

	CoInitialize(NULL);

	if( S_OK!=CoCreateInstance( CLSID_DirectMusicPerformance, NULL, CLSCTX_INPROC,
						IID_IDirectMusicPerformance, (void**)&m_pDirectMusicPerf ) )
		return false;

//	m_pDirectMusicPerf->Init(NULL);
//	m_pDirectMusicPerf->AddPort(NULL);

//////////////////////////////////////////
/*	IDirectMusic* pM = NULL;
	m_pDirectMusicPerf->Init(&pM);

	IDirectMusicPort* pPort = NULL;

	DMUS_PORTCAPS dmpc;
	memset(&dmpc,0,sizeof(dmpc));
	dmpc.dwSize = sizeof(dmpc);
	HRESULT hr;
	GUID guid;
	const GUID guidZero = {0};

	for(DWORD i=0; hr==S_OK; i++)
	{
		hr = pM->EnumPort(i,&dmpc);
		if(hr==S_FALSE)
			continue;
		if ( (dmpc.dwClass == DMUS_PC_OUTPUTCLASS) &&
			(dmpc.dwFlags & DMUS_PC_SOFTWARESYNTH) )
		{
			CopyMemory(&guid, &dmpc.guidPort, sizeof(GUID));
            DMUS_PORTPARAMS dmos;
			memset(&dmos,0,sizeof(dmos));
			dmos.dwSize = sizeof(dmos);
			hr = pM->CreatePort(guid, guidZero, &dmos, &pPort, NULL);
            break;
        }
    }

	pM->Activate(hwnd, TRUE);
	m_pDirectMusicPerf->AddPort(pPort);

	m_pDirectMusicPerf->AssignPChannelBlock(0, pPort, 1);
	pPort->Release();
*//////////////////////////////////

	if( S_OK!=CoCreateInstance( CLSID_DirectMusicLoader, NULL, CLSCTX_INPROC,
						IID_IDirectMusicLoader, (void**)&m_pDirectMusicLoader ) )
		return false;


	char dir[_MAX_PATH];
	WCHAR wszDir[_MAX_PATH];

	GetModuleFileName( NULL,dir,_MAX_PATH );
	char dv[_MAX_DRIVE] , direc[_MAX_DIR] , file[_MAX_FNAME] , ext[_MAX_EXT];
	_splitpath( dir, dv, direc, file, ext );
	_makepath( dir, dv, direc ,NULL,NULL);
	MULTI_TO_WIDE( wszDir, dir );

	m_pDirectMusicLoader->SetSearchDirectory( GUID_DirectMusicAllTypes, wszDir, FALSE );

	m_bInit = true;
	return true;
}

void CDirectMusic::ReleaseAll()
{
	if( !m_bInit )
		return;

	m_pDirectMusicPerf->Stop( NULL, NULL, 0, 0 );
	m_pDirectMusicPerf->CloseDown();
	m_pDirectMusicPerf->Release();

	m_pDirectMusicLoader->Release();

	CoUninitialize();

	m_bInit = false;
}

bool CDirectMusic::CreateSegment(CDirectMusicSegment* pS,LPCTSTR midName)
{
	if( !m_bInit )
		return false;

	IDirectMusicSegment* pSeg;
	HRESULT hr;

	WCHAR wsz[_MAX_PATH];
	MULTI_TO_WIDE( wsz , midName );

	DMUS_OBJECTDESC desc;
	desc.guidClass = CLSID_DirectMusicSegment;
	desc.dwSize = sizeof(DMUS_OBJECTDESC);
	wcscpy( desc.wszFileName, wsz );
	desc.dwValidData = DMUS_OBJ_CLASS | DMUS_OBJ_FILENAME;

	hr = m_pDirectMusicLoader->GetObject( &desc, IID_IDirectMusicSegment, (void**)&pSeg );
	if( hr!=S_OK )
		return false;

	pS->Initialize(&pSeg);
	pSeg->Release();
	return true;
}

void CDirectMusic::PlaySegment(CDirectMusicSegment * pSeg)
{
	if( !m_bInit )
		return;

	HRESULT hr;
	hr = m_pDirectMusicPerf->PlaySegment(pSeg->m_pSegment, DMUS_SEGF_DEFAULT, 0, NULL);
}
