// DirectSoundBuffer.cpp: CDirectSoundBuffer NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "DirectSoundBuffer.h"
#include "GrobalMain.h"

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

extern CGrobalMain g;

CDirectSoundBuffer::CDirectSoundBuffer()
{
	m_pBuffer = NULL;
	m_pDupBuffer[0] = NULL;
	m_pDupBuffer[1] = NULL;
	m_pDupBuffer[2] = NULL;
	m_pDupBuffer[3] = NULL;
	m_pDupBuffer[4] = NULL;
}

CDirectSoundBuffer::~CDirectSoundBuffer()
{
	Release();
}

void CDirectSoundBuffer::Initialize(IDirectSoundBuffer** ppBuf)
{
	m_pBuffer = *ppBuf;
	m_pBuffer->AddRef();
}

void CDirectSoundBuffer::Release()
{
	if( m_pBuffer!=NULL )
	{
		m_pBuffer->Release();
		m_pBuffer = NULL;
	}

	for( int i=0; i!=5; i++ )
	{
		if( m_pDupBuffer[i]!=NULL )
		{
			m_pDupBuffer[i]->Release();
			m_pDupBuffer[i] = NULL;
		}
	}
}

bool CDirectSoundBuffer::IsPlaying()
{
	if( m_pBuffer==NULL )
		return false;

	DWORD dwState;
	m_pBuffer->GetStatus(&dwState);
	if( dwState & DSBSTATUS_PLAYING )
		return true;
	return false;
}

void CDirectSoundBuffer::Play(bool bLoop)
{
	if( !g.m_bSOUND )
		return;

	if( m_pBuffer==NULL )
		return;

	if( !IsPlaying() )
	{
		if( bLoop )
			m_pBuffer->Play(0,0,DSBPLAY_LOOPING);
		else
			m_pBuffer->Play(0,0,0);
	}
	else
	{
		for( int i=0; i!=5; i++ )
		{
			if( m_pDupBuffer[i]!=NULL )
			{
				DWORD dwState;
				m_pDupBuffer[i]->GetStatus(&dwState);
				if( dwState & DSBSTATUS_PLAYING )
					continue;

				if( bLoop )
					m_pDupBuffer[i]->Play(0,0,DSBPLAY_LOOPING);
				else
					m_pDupBuffer[i]->Play(0,0,0);
				break;
			}
		}
	}
}

void CDirectSoundBuffer::Stop()
{
	if( IsPlaying() )
		m_pBuffer->Stop();
}

void CDirectSoundBuffer::SetDupBuffer(IDirectSoundBuffer **ppBuf , int No )
{
	if( 0 <= No && No <=4 )
	{
		m_pDupBuffer[No] = *ppBuf;
		m_pDupBuffer[No]->AddRef();
	}
}
