// GrobalMain.cpp: CGrobalMain NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "inc.h"
#include "GrobalMain.h"

#include "DirectMusicSegment.h"
#include "DirectSoundBuffer.h"
#include "D3DFrame.h"
#include "D3DMeshBuilder.h"
#include "D3DLight.h"
#include "Vector.h"

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CGrobalMain::CGrobalMain()
{
	m_TitleSel = 0;
	m_OptionSel = 0;
	m_Chara0No = 0;
	m_Chara1No = 0;
	m_bCom0 = false;
	m_bCom1 = false;
	m_BattleNo = 0;

	m_CurrentMIDI[0] = '\0';

	m_SkipFrame = 1;
	m_bSOUND = true;
	m_bMIDI = true;
}

CGrobalMain::~CGrobalMain()
{

}

void CGrobalMain::Start(HINSTANCE hi, HWND hw)
{
////////// {If[^ ///////////////////////////////
	m_hInstance = hi;
	m_hWnd = hw;

////////// gf[^ ///////////////////////////////
	ds.Initialize(m_hWnd);
	di.Initialize(m_hInstance,m_hWnd);
	di.AcquireKey();
	dd.Initialize(m_hWnd,640,480,16);
	pbk = new CDirectDrawSurface;
	dd.GetBackSurface(pbk);

	time_t t;
	srand(time(&t));
////////// \[X[h /////////////////////////////////
	dd.CreateSurface(&m_CurLightS,"Res\\CurLight.bmp");
	m_CurLightS.SetColorKey( RGB(0,0,0) );
	dd.CreateSurface(&m_CurDarkS,"Res\\CurDark.bmp");
	m_CurDarkS.SetColorKey( RGB(0,0,0) );
	dd.CreateSurface(&m_WakuRS,"Res\\WakuR.bmp");
	m_WakuRS.SetColorKey(RGB(0,0,0));
	dd.CreateSurface(&m_WakuBS,"Res\\WakuB.bmp");
	m_WakuBS.SetColorKey(RGB(0,0,0));

	dd.CreateSurface(&m_TitleS,"Res\\Title.bmp");
	dd.CreateSurface(&m_OptionS,"Res\\Option.bmp");
	dd.CreateSurface(&m_BackS,"Res\\Back.bmp");
	dd.CreateSurface(&m_ShoriS,"Res\\Shori.bmp");
	dd.CreateSurface(&m_StartS,"Res\\Start.bmp");
	dd.CreateSurface(&m_StoryS,"Res\\Story.bmp");

	ds.CreateSoundBuffer(&Tirolin,"Res\\Tirolin.wav");
	ds.CreateSoundBuffer(&Saa,"Res\\Saa.wav");
	ds.CreateSoundBuffer(&Boon,"Res\\Boon.wav");
	CCharactor::pBoon = &Boon;
// Lf[^[h /////////////////////////////////////
	m_CharaList[0].Init( CCharactor::COM1 , 100 , HT_TO_VG(180,1.2) , "^[" , "Res\\Ch1.bmp" , &dd );
	m_CharaList[1].Init( CCharactor::COM2 , 80 , HT_TO_VG(220,2.4) , "W[" , "Res\\Ch2.bmp" , &dd );
	m_CharaList[2].Init( CCharactor::COM3 , 180 , HT_TO_VG(140,1.0) , "Tu" , "Res\\Ch3.bmp" , &dd );
	m_CharaList[3].Init( CCharactor::COM4 , 50 , HT_TO_VG(200,0.5) , "{" , "Res\\Ch4.bmp" , &dd );
	m_CharaList[4].Init( CCharactor::COM5 , 120 , HT_TO_VG(60,7.5) , "" , "Res\\Ch5.bmp" , &dd );
	m_CharaList[5].Init( CCharactor::COM6 , 105 , HT_TO_VG(180,1.2) , "Ag" , "Res\\Ch6.bmp" , &dd );
	m_CharaList[6].Init( CCharactor::COM7 , -200 , HT_TO_VG(220,1.5) , "S}" , "Res\\Ch7.bmp" , &dd );
	m_CharaList[7].Init( CCharactor::COM8 , 95 , HT_TO_VG(160,1.2) , "" , "Res\\Ch8.bmp" , &dd );

// X^[g //////////////////////////////////////////////
	m_Mode = TITLE;
	StartTimer();
}

void CGrobalMain::End()
{
	EndTimer();
	delete pbk;
}

void CGrobalMain::StartTimer()
{
//	timeBeginPeriod( 10 );
//	m_TimerID = timeSetEvent( 50,10,MMTimerProc,(unsigned long)((void*)this),TIME_PERIODIC );
	m_TimerID = 178116;
	SetTimer(m_hWnd, m_TimerID, 50, NULL);
}

void CGrobalMain::EndTimer()
{
//	timeKillEvent( m_TimerID );
//	timeEndPeriod( 10 );
	KillTimer( m_hWnd , m_TimerID );
}

void CALLBACK CGrobalMain::MMTimerProc( UINT uID , UINT uMsg , DWORD dwUser , DWORD dw1 , DWORD dw2 )
{
	CGrobalMain* p = (CGrobalMain*)dwUser;
	PostMessage( p->m_hWnd,BNM_MMTIMER,uID,NULL );
}

void CGrobalMain::PlayMIDI()
{
	mciSendCommand( m_midi,MCI_CLOSE,NULL,NULL );

	if( !m_bMIDI )
		return;

	MCI_OPEN_PARMS mciOpen;
	mciOpen.dwCallback = (DWORD)m_hWnd;
	mciOpen.lpstrDeviceType = "sequencer";
	mciOpen.lpstrElementName = m_CurrentMIDI;

	DWORD rtn = mciSendCommand( NULL,MCI_OPEN,MCI_OPEN_TYPE | MCI_OPEN_ELEMENT,(DWORD)(LPVOID)&mciOpen);
	if( rtn!=0 )
		return;

	m_midi = mciOpen.wDeviceID;

	MCI_PLAY_PARMS mciPlay;
	mciPlay.dwCallback = (DWORD)m_hWnd;

	rtn = mciSendCommand( m_midi,MCI_PLAY,MCI_NOTIFY,(DWORD)&mciPlay);
}

void CGrobalMain::ReplayMIDI()
{
    MCI_SEEK_PARMS mciSeek;
	mciSendCommand(m_midi, MCI_SEEK,MCI_SEEK_TO_START,(DWORD)(LPVOID) &mciSeek);
	MCI_PLAY_PARMS mciPlay;
	mciPlay.dwCallback = (DWORD)m_hWnd;
	mciSendCommand( m_midi,MCI_PLAY,MCI_NOTIFY,(DWORD)(LPVOID)&mciPlay);
}

void CGrobalMain::Activate(BOOL bActive)
{
	if( bActive && !m_bActive )
	{
		PlayMIDI();

		SetCursor(NULL);

		m_bActive = true;
		dd.RestoreAll();
		
		StartTimer();
	}
	else if( !bActive && m_bActive )
	{
		mciSendCommand( m_midi,MCI_CLOSE,NULL,NULL );
		m_bActive = false;

		EndTimer();
	}
}

void CGrobalMain::Timer(UINT ID)
{
	if(!m_bActive)
		return;

	if( di.IsKeyDown(DIK_ESCAPE) )
	{
		PostQuitMessage(0);
		return;
	}

	switch( m_Mode )
	{
	case TITLE:		TitleProc();	break;
	case OPTION:	OptionProc();	break;
	case VS_2P:
	case VS_COM:	VsProc();	break;
	default:	PostQuitMessage(0);	break;
	}
}

void CGrobalMain::TitleProc()
{
	if( 0!=strcmp(m_CurrentMIDI,"Res\\Open.mid") )
	{
		strcpy(m_CurrentMIDI,"Res\\Open.mid");
		PlayMIDI();
	}

	// L[
	if( di.IsKeyDown(DIK_RETURN) )
	{
		Tirolin.Play();
		Sleep(200);
		switch( m_TitleSel )
		{
		case 0:
			m_Mode = VS_2P;
			m_ModeDetail = CHARSEL;
			break;
		case 1:
			m_Mode = VS_COM;
			m_ModeDetail = CHARSEL;
			if( m_BattleNo==8 )
				m_BattleNo = 0;
			m_Chara1No = m_BattleNo;
			m_bCom1 = true;
			break;
		case 2:
			m_Mode = OPTION;
			break;
		}
	}
	else if( di.IsKeyDown(DIK_DOWN) || di.IsKeyDown(DIK_D) )
	{
		Saa.Play();
		Sleep(100);
		m_TitleSel++;
		if( m_TitleSel==3 )
			m_TitleSel=0;
	}
	else if( di.IsKeyDown(DIK_UP) || di.IsKeyDown(DIK_E) )
	{
		Saa.Play();
		Sleep(100);
		m_TitleSel--;
		if( m_TitleSel==-1 )
			m_TitleSel=2;
	}

	RECT rcTo = { 0,0,640,480 };
	RECT rcFrom = { 0,0,m_TitleS.Width(),m_TitleS.Height() };
	pbk->Blt( &rcTo , &m_TitleS , &rcFrom , DDBLT_WAIT , NULL );

	RECT rcTo2 = { 100,250+m_TitleSel*64,132,250+m_TitleSel*64+32 };
	RECT rcFrom2 = { 0,0,32,32 };
	pbk->Blt( &rcTo2 , &m_CurLightS , &rcFrom2 , DDBLT_WAIT|DDBLT_KEYSRC , NULL );

	dd.Flip();
}

void CGrobalMain::OptionProc()
{
	if( 0!=strcmp(m_CurrentMIDI,"Res\\Open.mid") )
	{
		strcpy(m_CurrentMIDI,"Res\\Open.mid");
		PlayMIDI();
	}

	// L[
	if( di.IsKeyDown(DIK_RETURN) )
	{
		Tirolin.Play();
		Sleep(100);
		m_Mode = TITLE;
	}
	else if( di.IsKeyDown(DIK_DOWN) || di.IsKeyDown(DIK_D) )
	{
		Sleep(100);
		m_OptionSel++;
		if( m_OptionSel==3 )
			m_OptionSel=0;
	}
	else if( di.IsKeyDown(DIK_UP) || di.IsKeyDown(DIK_E) )
	{
		Sleep(100);
		m_OptionSel--;
		if( m_OptionSel==-1 )
			m_OptionSel=2;
	}
	else if( di.IsKeyDown(DIK_RIGHT) || di.IsKeyDown(DIK_F) )
	{
		Saa.Play();
		Sleep(100);
		switch( m_OptionSel )
		{
		case 0: m_bSOUND=!m_bSOUND;	break;
		case 1: m_bMIDI=!m_bMIDI;	PlayMIDI();	break;
		case 2:
			if( m_SkipFrame==1 )		m_SkipFrame=5;
			else if( m_SkipFrame==5 )	m_SkipFrame=10;
			else if( m_SkipFrame==10 )	m_SkipFrame=1;
			break;
		}
	}
	else if( di.IsKeyDown(DIK_LEFT) || di.IsKeyDown(DIK_S) )
	{
		Saa.Play();
		Sleep(100);
		switch( m_OptionSel )
		{
		case 0: m_bSOUND=!m_bSOUND;	break;
		case 1: m_bMIDI=!m_bMIDI;	PlayMIDI();	break;
		case 2:
			if( m_SkipFrame==1 )		m_SkipFrame=10;
			else if( m_SkipFrame==5 )	m_SkipFrame=1;
			else if( m_SkipFrame==10 )	m_SkipFrame=5;
			break;
		}
	}


	// obN`
	RECT rcTo = { 0,0,640,480 };
	RECT rcFrom = { 0,0,m_OptionS.Width(),m_OptionS.Height() };
	pbk->Blt( &rcTo , &m_OptionS , &rcFrom , DDBLT_WAIT , NULL );
	// J[\`
	rcFrom.right=rcFrom.bottom=32;

	if( m_bSOUND )	rcTo.right = 360;
	else			rcTo.right = 460;
	rcTo.top = 60;
	rcTo.left = rcTo.right-32;	rcTo.bottom = rcTo.top+32;
	if( m_OptionSel==0 )
		pbk->Blt( &rcTo,&m_CurLightS,&rcFrom,DDBLT_WAIT|DDBLT_KEYSRC,NULL );
	else
		pbk->Blt( &rcTo,&m_CurDarkS,&rcFrom,DDBLT_WAIT|DDBLT_KEYSRC,NULL );

	if( m_bMIDI )	rcTo.right = 360;
	else			rcTo.right = 460;
	rcTo.top = 160;
	rcTo.left = rcTo.right-32;	rcTo.bottom = rcTo.top+32;
	if( m_OptionSel==1 )
		pbk->Blt( &rcTo,&m_CurLightS,&rcFrom,DDBLT_WAIT|DDBLT_KEYSRC,NULL );
	else
		pbk->Blt( &rcTo,&m_CurDarkS,&rcFrom,DDBLT_WAIT|DDBLT_KEYSRC,NULL );

	if( m_SkipFrame==1 )			rcTo.right = 360;
	else if( m_SkipFrame==5 )		rcTo.right = 460;
	else							rcTo.right = 560;
	rcTo.top = 260;
	rcTo.left = rcTo.right-32;	rcTo.bottom = rcTo.top+32;
	if( m_OptionSel==2 )
		pbk->Blt( &rcTo,&m_CurLightS,&rcFrom,DDBLT_WAIT|DDBLT_KEYSRC,NULL );
	else
		pbk->Blt( &rcTo,&m_CurDarkS,&rcFrom,DDBLT_WAIT|DDBLT_KEYSRC,NULL );

	dd.Flip();
}

void CGrobalMain::VsProc()
{
	if( m_Mode==VS_COM )
	{
		if( 0!=strcmp(m_CurrentMIDI,"Res\\Battle1.mid") )
		{
			strcpy(m_CurrentMIDI,"Res\\Battle1.mid");
			PlayMIDI();
		}
	}
	if( m_Mode==VS_2P )
	{
		if( 0!=strcmp(m_CurrentMIDI,"Res\\Battle2.mid") )
		{
			strcpy(m_CurrentMIDI,"Res\\Battle2.mid");
			PlayMIDI();
		}
	}

	switch( m_ModeDetail )
	{
	case CHARSEL:
		CharSelProc();
		return;
	case WIN:
		WinProc();
		return;
	case STORY:
		StoryProc();
		return;
	case STOP:
		{
			if( di.IsKeyDown(DIK_RETURN) )
			{
				Tirolin.Play();
				Sleep(200);
				m_ModeDetail = BATTLE;
			}
			return;
		}
	}

	// ogEX^[gʕ`
	static clock_t cl;
	static bool bBStartCall = true;
	if( bBStartCall )
	{
		cl = clock();
		bBStartCall = false;
	}
	if( clock()-cl <= 1000 )
	{
		RECT rcStartTo = { 0,0,640,480 };
		RECT rcStartFrom = { 0,0,m_StartS.Width(),m_StartS.Height() };
		pbk->Blt( &rcStartTo , &m_StartS , &rcStartFrom , DDBLT_WAIT , NULL );
		dd.Flip();
		return;
	}




	// |[Y
	if( di.IsKeyDown(DIK_RETURN) )
	{
		Tirolin.Play();
		Sleep(200);
		m_ModeDetail = STOP;
		return;
	}

	// vl
	char k[256];
	di.GetKeyState(sizeof(k),k);

	CCharactor tmp0,tmp1;
	tmp0.CopyInfo( m_pCh0,0 );
	tmp1.CopyInfo( m_pCh1,1 );

	m_pCh0->Think(k,&tmp1,0);
	m_pCh1->Think(k,&tmp0,1);

	// ړ
	static clock_t last;
	static bool bFirstCall = true;
	if( bFirstCall )
	{
		last = clock();
		bFirstCall = false;
	}
	clock_t now = clock();

	if( now-last > 300 )
		last = now;

	for( int i=0; i<now-last; i+=m_SkipFrame )
	{
		// Po
		m_pCh0->Act(m_SkipFrame,0);
		CCharactor::Clip(m_pCh0,0);
		// Qo
		m_pCh1->Act(m_SkipFrame,1);
		CCharactor::Clip(m_pCh1,1);
		// 蔻
		m_Res = CCharactor::WhichWin(m_pCh0,m_pCh1);
		if( m_Res!=0 )	break;
	}

	last = now;


	// `
	RECT rcTo = { 0,0,640,480 };
	RECT rcFrom = { 0,0,m_BackS.Width(),m_BackS.Height() };
	pbk->Blt( &rcTo , &m_BackS , &rcFrom , DDBLT_WAIT , NULL );

	m_pCh0->Draw( pbk,0 );
	m_pCh1->Draw( pbk,1 );

	dd.Flip();

	if( m_Res!=0 )
	{
		bFirstCall = true;
		bBStartCall = true;
		m_ModeDetail = WIN;
	}
}

void CGrobalMain::CharSelProc()
{
	// L[
	if( di.IsKeyDown(DIK_RETURN) )
	{
		Tirolin.Play();
		Sleep(200);

		m_pCh0 = &(m_CharaList[m_Chara0No]);
		if( m_bCom0 )
			m_pCh0->StartGame(CCharactor::DEFAULT,0);
		else
			m_pCh0->StartGame(CCharactor::KEY1,0);
		m_pCh1 = &(m_CharaList[m_Chara1No]);
		if( m_bCom1 )
			m_pCh1->StartGame(CCharactor::DEFAULT,1);
		else
			m_pCh1->StartGame(CCharactor::KEY2,1);

		if( m_Mode == VS_2P )
			m_ModeDetail=BATTLE;
		else
			m_ModeDetail=STORY;
		return;
	}

	if( di.IsKeyDown(DIK_F) )
	{
		Saa.Play();
		Sleep(100);
		m_Chara0No++;
		if( m_Chara0No==8 )
			m_Chara0No=0;
	}
	else if( di.IsKeyDown(DIK_S) )
	{
		Saa.Play();
		Sleep(100);
		m_Chara0No--;
		if( m_Chara0No==-1 )
			m_Chara0No=7;
	}
	else if( di.IsKeyDown(DIK_D) || di.IsKeyDown(DIK_E) )
	{
		Saa.Play();
		Sleep(100);
		m_bCom0=!m_bCom0;
	}

	if( di.IsKeyDown(DIK_RIGHT) && m_Mode==VS_2P  )
	{
		Saa.Play();
		Sleep(100);
		m_Chara1No++;
		if( m_Chara1No==8 )
			m_Chara1No=0;
	}
	else if( di.IsKeyDown(DIK_LEFT) && m_Mode==VS_2P )
	{
		Saa.Play();
		Sleep(100);
		m_Chara1No--;
		if( m_Chara1No==-1 )
			m_Chara1No=7;
	}
	else if( di.IsKeyDown(DIK_DOWN) || di.IsKeyDown(DIK_UP) && m_Mode==VS_2P )
	{
		Saa.Play();
		Sleep(100);
		m_bCom1=!m_bCom1;
	}

	// `
	DDBLTFX fx;
	fx.dwSize = sizeof(fx);
	fx.dwFillColor=0;
	pbk->Blt( NULL,NULL,NULL,DDBLT_WAIT|DDBLT_COLORFILL,&fx );

	m_CharaList[m_Chara0No].DrawName(pbk,50,50);
	m_CharaList[m_Chara1No].DrawName(pbk,50,250);

	for( int i=0; i!=8; i++ )
	{
		m_CharaList[i].SetPos( CVector(152+48*i,148,0),0 );
		m_CharaList[i].Draw( pbk,0 );
		m_CharaList[i].SetPos( CVector(152+48*i,380,0),1 );
		m_CharaList[i].Draw( pbk,1 );
	}

	RECT rcFrom = { 0,0,54,54 };
	RECT rcTo;

	rcTo.left = 125+48*m_Chara0No;
	rcTo.top=97;	rcTo.right=rcTo.left+54;	rcTo.bottom=rcTo.top+54;
	if( m_bCom0 )	pbk->Blt( &rcTo , &m_WakuBS , &rcFrom , DDBLT_WAIT|DDBLT_KEYSRC , NULL );
	else			pbk->Blt( &rcTo , &m_WakuRS , &rcFrom , DDBLT_WAIT|DDBLT_KEYSRC , NULL );

	rcTo.left = 125+48*m_Chara1No;
	rcTo.top=329;	rcTo.right=rcTo.left+54;	rcTo.bottom=rcTo.top+54;
	if( m_bCom1 )	pbk->Blt( &rcTo , &m_WakuBS , &rcFrom , DDBLT_WAIT|DDBLT_KEYSRC , NULL );
	else			pbk->Blt( &rcTo , &m_WakuRS , &rcFrom , DDBLT_WAIT|DDBLT_KEYSRC , NULL );

	dd.Flip();
}

void CGrobalMain::WinProc()
{
	static clock_t cl;
	static bool bFirstCall = true;

	if( bFirstCall )
	{
		cl = clock();
		bFirstCall = false;
	}

	if( clock() - cl <= 1500 )
		return;

	if( clock() - cl >= 5000 )
	{
		bFirstCall = true;
		if( m_Mode==VS_2P )
			m_Mode=TITLE;
		else
		{
			if( m_Res==1 )
				m_Mode=TITLE;
			else
			{
				m_ModeDetail=STORY;
				m_BattleNo++;
			}
		}
		m_Res=0;
		return;
	}

	RECT rcTo = { 0,0,640,480 };
	RECT rcFrom = { 0,0,m_ShoriS.Width(),m_ShoriS.Height() };
	pbk->Blt( &rcTo , &m_ShoriS , &rcFrom , DDBLT_WAIT , NULL );

	if( m_Res==-1 )
	{
		m_pCh0->SetPos( CVector(320,100,0) , 0 );
		m_pCh0->Draw(pbk,0);
	}
	else
	{
		m_pCh1->SetPos( CVector(320,100,0) , 1 );
		m_pCh1->Draw(pbk,1);
	}

	dd.Flip();
}

void CGrobalMain::StoryProc()
{
	char str[1000];

	switch( m_BattleNo )
	{
	case 0:
		strcpy(str,"\ń\n\nAȂ́AˑRɏoBAmʒjɏ𒧂܂ꂽB̒j́Au^[vƖB");
		break;
	case 1:
		strcpy(str,"\ń\n\nW[uZM̋wAo債IIv");
		break;
	case 2:
		strcpy(str,"\nÓ\n\nTuuZM̈ƌZM̓̋wAo債IIIv");
		break;
	case 3:
		strcpy(str,"\nĺ\n\n{uَ҂Ƃ荇킹肨Bv");
		break;
	case 4:
		strcpy(str,"\n܏́\n\nuZMi{j̋wIIv");
		break;
	case 5:
		strcpy(str,"\nŹ\n\nAguȂ͖l|ɂ`̗E҂łˁB͒ʂ܂Iv");
		break;
	case 6:
		strcpy(str,"\n掵́\n\nS}uO|ɂ̂II蕿͂䂸񂼁Bv\n");
		break;
	case 7:
		strcpy(str,"\n攪́\n\nuӂ͂͂́B悭܂łǂ蒅BŋMlI肾IIv\n");
		break;
	case 8:
		strcpy(str,"Í\n\nĂ͓AaȐ̒ɂȂ܂ƂB߂ł߂łB");
		break;
	}


	static clock_t cl;
	static bool bFirstCall = true;

	if( bFirstCall )
	{
		cl = clock();
		bFirstCall = false;
	}

	// L[
	if( di.IsKeyDown(DIK_RETURN) )
	{
		Sleep(200);
		cl = clock()-10000;
	}

	if( clock() - cl >= 5000 )
	{
		if( m_BattleNo==8 )
		{
			m_Mode=TITLE;
		}
		else
		{
			m_ModeDetail=BATTLE;
			m_bCom1 = true;
			if( !m_bCom0 )
				m_pCh0->StartGame( CCharactor::KEY1,0 );
			else
				m_pCh0->StartGame( CCharactor::DEFAULT,0 );

			m_pCh1 = &(m_CharaList[m_BattleNo]);
			m_pCh1->StartGame( CCharactor::DEFAULT,1 );
		}
		bFirstCall=true;
		return;
	}

	RECT rcTo = { 0,0,640,480 };
	RECT rcFrom = { 0,0,m_StoryS.Width(),m_StoryS.Height() };
	pbk->Blt( &rcTo , &m_StoryS , &rcFrom , DDBLT_WAIT , NULL );

	HDC hdc;
	pbk->GetDC(&hdc);
		SetBkColor(hdc,RGB(0,0,0));
		SetTextColor(hdc,RGB(255,255,255));
		RECT rc = {120,120,510,350};
		DrawText(hdc,str,strlen(str),&rc,DT_WORDBREAK);
	pbk->ReleaseDC(hdc);

	dd.Flip();
}
